/* thrdmutex.c */

/* due thread condividono una risorsa sincronizzandosi con
 * una mutex											*/

#include <stdio.h>
#include <unistd.h>
#include <pthread.h>

pthread_mutex_t mutex;
int global_i = 0;
int accumulator;

void * incr(void * x)
{
	for (;;) {
		pthread_mutex_lock(&mutex);  // if critical section unlocked
		accumulator = global_i;      // accumulator may be printed
		accumulator++;               // greater than global_i
		usleep(1000L);
		global_i = accumulator;
//		printf("global_i = %d   accumulator = %d ", 
//		       global_i, accumulator);
		pthread_mutex_unlock(&mutex);
	}
}

void * print(void * x)
{
	for (;;) {
		pthread_mutex_lock(&mutex);
		printf("global_i = %d\taccumulator = %d\n", 
		       global_i, accumulator);
		usleep(3000L);
		pthread_mutex_unlock(&mutex);
	}
}

int main(int argc,char *argv[])
{
	pthread_t incr_id, print_id;

	pthread_mutex_init(&mutex, NULL);  // NULL: default mutex attrs	
	pthread_create(&incr_id, NULL, incr, NULL);
	pthread_create(&print_id, NULL, print, NULL);
	pthread_join(incr_id, NULL);
	pthread_join(print_id, NULL);
	return 0;
}
