/* thrdprodcons.c */

/* Thread producer-consumer */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <limits.h>
#include <pthread.h>

#include "synqueue.h"

#define MAXCONS 4

syn_queue_t queue;
int qsize, cons_n;

void * producer(void * x)
{
	long n, i = 0;
	
	show_str(0, "prod", "created");   // activate defining debug
	for (;;) {
		n = rand() % (cons_n * qsize) + 1;
		while (n-- > 0)
			q_put(&queue, i++);
		sleep(1);
	}
}

void * consumer(void * x)
{
	long v, n;
	int nr;

	nr = *((int * ) x);
	show_str(nr, "cons", "created");   // activate defining debug
	for (;;) {
		n = rand() % (2*qsize) + 1;
		while (n-- > 0)
			q_get(&queue, &v, nr);
		sleep(1);
	}
}
////

int main(int argc, char *argv[])
{
	pthread_t thrd[1+MAXCONS];
	int i;
	int indx[1+MAXCONS]; // indx[0] unused

	if ( argc != 3 ||
	     (cons_n = atoi(argv[2])) > MAXCONS ) {
		printf("Usage: %s qsize #_consumers (<= %d)\n", 
		       argv[0], MAXCONS);
		exit(1);
	}

	q_init(&queue, qsize = atoi(argv[1]));	// should check ret value
	srand((unsigned int) time(NULL));
	for (i = 1; i <= cons_n; i++) {
		indx[i] = i;
		pthread_create(&thrd[i], NULL, consumer, 
		               (void *) &indx[i]);
	}
	pthread_create(&thrd[0],  NULL, producer, NULL);
// main thread should wait for created threads to terminate, 
// also because it is passing them an arg pointing to its stack


	pthread_exit(NULL);
	
//	exit(0);
}
